


import game.*;
import java.awt.*;
import java.util.*;

public class Background extends Sprite
{
	public static final int CLASS_ID = "Background".hashCode();
	private Star[] stars = new Star[30];
	private static final Color[] colors = { Color.blue, Color.yellow, Color.green };
	public Background( SpriteVector spriteVector, Component component )
	{
		super( CLASS_ID, spriteVector, component, component.getBounds(), 0 );
		int x, y;
		for( int i = 0; i < 30; i++ )
		{
			createStar( i );
		}
	}

	public void collisionDetected( Sprite sprite )
	{}

	public void refresh( Graphics g )
	{
		draw(g);
	}

	public void draw( Graphics g )
	{
		g.setColor( Color.black );
		g.fillRect( 0, 0, component.getBounds().width, component.getBounds().height );
		Star star;
		for( int i = stars.length-1; i > -1; i-- )
		{
			star = stars[i];
			g.setColor( star.color );
			g.fillRect( star.x, star.y, star.width, star.height );
			if( star.y > component.getBounds().width )
			{
				star.y = -5;
			}
			star.y += URandom.getRandomInt(5, 10);
			
		}
	}

	public void createStar( int index )
	{
		Star s = new Star();
		s.x = URandom.getRandomInt(0,component.getBounds().width);
		s.y = URandom.getRandomInt(0,component.getBounds().height);
		s.width = 1;
		s.height = 1; 
		s.color = colors[ URandom.getRandomInt(3) ];
		stars[index] = s;	
	}

	private class Star
	{
		Color color;
		int x;
		int y;
		int width;
		int height;
	}

}


