import game.*;
import java.awt.*;

public class Bonus extends Sprite
{
	public static final int PENETRATING = 0;
	public static final int EXPLODING = 2;
	public static final int INVULNERABILITY = 1;

	public static final int CLASS_ID = "Bonus".hashCode();
	private int type;

	public Bonus( SpriteVector spriteVector, Component component, int xPosition, int yPosition, int type )
   {
		super( CLASS_ID, spriteVector, component, new Rectangle(xPosition, yPosition,10,10), 0);		
		this.type = type;
		collisionWidth = 200;
		collisionHeight = 200;
	}

	public void collisionDetected( Sprite sprite )
	{
		if( isDead() )
		{
			return;
		}
		if( sprite.getTypeID() == Missile.CLASS_ID && ((Missile)sprite).getOwner().getTypeID() == Canon.CLASS_ID )
		{
			GameProperties.setProperty( Gatesians.BONUS, this );
			kill();
		}
	}

	public String getText()
	{
		switch( type )
		{
			case INVULNERABILITY:
			{
				return "Bonus: Invulnerability!";
			}
			case EXPLODING:
			{
				return "Bonus: Exploding missile!";
			}
		}
		return "Bonus: Super missile!";
	
	}

	public static Color getColor( int type )
	{
		switch( type )
		{
			case INVULNERABILITY:
			{
				return Color.yellow;
			}
			case EXPLODING:
			{
				return Color.white;
			}
		}
		return Color.green;
	}

	public Color getColor()
	{
		return getColor( type );
	}

	public int getType()
	{
		return type;
	}

	public void draw( Graphics g )
	{
		if( isDead() )
		{
			return;
		}
		g.setColor( getColor() );
		g.fillRect( xPosition, yPosition, getWidth(), getHeight() );
		xPosition += 5;
	}



}
