
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import game.*;

public class GameApplet extends Applet implements ActionListener
{
	private Label levelLabel  = new Label("Level : 0      ");
	private Label bonusLabel  = new Label("Bonus : 0      ");
	private Label scoreLabel  = new Label("Score: 0       ");
	private Label livesLabel  = new Label("Lives: 0        ");
	private Button startButton = new Button("Start");
	private Button stopButton = new Button("Stop");
	private Panel bottomPanel = new Panel();
	private Gatesians galaxians;
	private boolean started = false;
	private Canvas theCanvas = new Canvas();

	public void init()
	{
		GameProperties.applet = this;
		setFont( new Font("Helvetica", Font.BOLD, 13 ) );
		setBackground(Color.lightGray);
		setLayout( new BorderLayout(1,1));
		add( theCanvas, "Center");
		add( new Label("Gatesians - All programming by Ulrik Magnusson"), "North" );
		setSize(500,400);
		bottomPanel.setLayout( new FlowLayout(FlowLayout.LEFT) );
		bottomPanel.add( startButton );
		bottomPanel.add( stopButton );
		bottomPanel.add( levelLabel );
		bottomPanel.add( scoreLabel );
		bottomPanel.add( livesLabel );
		bottomPanel.add( bonusLabel );
		startButton.addActionListener( this );
		stopButton.addActionListener( this );
		add( bottomPanel, "South");
	}

	public void actionPerformed( ActionEvent e )
	{
		if( e.getSource() == startButton )
		{
			startGame();
		}
		else if( e.getSource() == stopButton )
		{
			stopGame();
		}
	}

	private void stopGame()
	{
		galaxians.stopGame();
	}

	private void startGame()
	{
		galaxians.startGame();
	}

	public void start()
	{
		started = true;
		invalidate();
		validate();
		galaxians = new Gatesians( this, theCanvas );
	}


	public void setLivesLeft( int n )
	{
		livesLabel.setText( "Lives left: " + n );
	}
	
	public void setScore( int n )
	{
		scoreLabel.setText( "Score: " + n );
	}

	public void setLevel( int n )
	{
		levelLabel.setText( "Level: " + n );
	}

	public void setBonus( int n )
	{
		bonusLabel.setText( "Bonus: " + n );
	}

	public void stop()
	{
		galaxians.stop();
	}


	
}
