package game;


// a sequence is a non-empty collection of images that is used as animation

import java.awt.*;
import java.util.*;
import java.applet.*;

public final class Sequence
{
	private Vector imageVector = new Vector();
	private int index = 0;
	private int width;
	private int height;
	private boolean complete = false;
	private MediaTracker tracker = new MediaTracker(GameProperties.applet);
	private static Hashtable images = new Hashtable();

	public Sequence()
	{
		imageVector.addElement(null);
	}


	public void addImage( String name )
	{
		if( imageVector.elementAt(0) == null )
		{
			imageVector.setElementAt( ImageLoader.getImage(name), 0 );
		}
		else
		{
			imageVector.addElement( ImageLoader.getImage(name) );
		}
	}

	public void addImage( Image i )
	{
		imageVector.addElement( i );
	}

	public void reset()
	{
		index = 0;
	}

	
	
	// returns true if resetting
	public Image advance()
	{
		if( ++index == imageVector.size() )
		{
			complete = true;
			index = 0;
		}
		else
		{
			complete = false;
		}
		return (Image)imageVector.elementAt(index);
	}

	public boolean isComplete()
	{
		return complete;
	}

	public Image getImage( )
	{
		return (Image)imageVector.elementAt(index);
	}

	public Image getImage( int i )
	{
		return (Image)imageVector.elementAt(i);
	}
}
