
package game;

import java.util.*;
import java.awt.*;

public class SpriteVector
{

	private Vector sprites = new Vector();
	private Sprite background = null;

	public void removeAll()
	{
		sprites = new Vector();
	}

	public void removeAll( int typeID )
	{
		for( int i = 0; i < sprites.size(); i++ )
		{
			if( ((Sprite)sprites.elementAt(i)).getTypeID() == typeID )
			{
				sprites.removeElementAt(i);
				i--;
			}
		}
	}

	// insert in z order
	// do a binary search in stead
	public void addSprite( Sprite sprite )
	{
		int objZ = sprite.getZOrder();
		int size = sprites.size();
		for( int i = 0; i < size; i++ )
		{
			if( ((Sprite)sprites.elementAt(i)).getZOrder() >= objZ )
			{
				sprites.insertElementAt(sprite,i);
				return;
			}
		}
		sprites.addElement(sprite);
	}

	public void event( EventObject event )
	{
		for( int i = 0; i < sprites.size(); i++ )
		{
			((Sprite)sprites.elementAt(i)).event(event);
		}
	}

	public void setBackground( Sprite sprite )
	{
		background = sprite;
	}

	public void detectCollisions()
	{
		Sprite obj1;
		Sprite obj2;
		for( int i = 0; i < sprites.size(); i++ )
		{
			obj1 = (Sprite)sprites.elementAt(i);
			if( obj1.isBuried() )
			{
				sprites.removeElementAt(i);
			}
			for( int j = 0; j < sprites.size(); j++ )
			{
				obj2 = (Sprite)sprites.elementAt(j);
				obj1.checkCollision(obj2);
			}
		}
	}

	public void update( Graphics g )
	{
		detectCollisions();
		if( background != null ) 
		{
			background.draw(g);
		}
		for( int i = 0; i < sprites.size(); i++ )
		{
			((Sprite)sprites.elementAt(i)).draw( g );
		}
	}

	public void refresh( Graphics g )
	{
		if( background != null )
		{
			background.refresh( g );
		}
		for( int i = 0; i < sprites.size(); i++ )
		{
			((Sprite)sprites.elementAt(i)).refresh( g );
		}
	}

}
